def fileNomServ=files['nomServ']
if(fileNomServ==null){
  throw new RuntimeException("Incarcati fisierul XLS!")
}

def locale = "ro";
def sdf="dd/MM/yyyy"
def insert=parameters['insert'];

def fields=jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomServQueryBuilder","getColumnLabels",[locale]).remoteSimpleObject;

def cloneWb=null;
def cloneSheet=null
//def liniiOK=[]
def suntErr=false;
def inregNecorespunzatoare=0
def inregAdaugate=0
def style=null;
def idList=[]

try{
  excelReader.iterateRow(fileNomServ, 1,true, {reader->
      int rowNo=reader.rowNo
      String sheetName=reader.sheetName
      if(cloneSheet==null){
        cloneWb= reader.cloneWorkBook();
        cloneSheet=cloneWb.getSheet(sheetName)
        style=cloneWb.createCellStyle();
        style.setBorderBottom(BorderStyle.MEDIUM);
        style.setBottomBorderColor(IndexedColors.RED.getIndex());
        style.setBorderLeft(BorderStyle.MEDIUM);
        style.setLeftBorderColor(IndexedColors.RED.getIndex());
        style.setBorderRight(BorderStyle.MEDIUM);
        style.setRightBorderColor(IndexedColors.RED.getIndex());
        style.setBorderTop(BorderStyle.MEDIUM);
        style.setTopBorderColor(IndexedColors.RED.getIndex());
      }
       
      def rowContext=[:]
      def rowFieldContext=[:]
      
      def completeazaMap={String numeColoanaXLS,String fieldEmsys,boolean trimZeros=false->
        def val=reader.getString(numeColoanaXLS);
        if(trimZeros&&val!=null&&val.endsWith('.0')){
          int idx=val.lastIndexOf('.0')
          val=val.substring(0,idx);
        }
        def  poz=reader.findPosition(numeColoanaXLS);
        def clonedRow=cloneSheet.getRow(rowNo);
        
        if (clonedRow.getCell(poz)==null){
          clonedRow.createCell(poz).setCellValue("");
        }
       
        def content=['cell':poz,'field':fieldEmsys,'xlsField':numeColoanaXLS,'value':val,'poiCell':clonedRow.getCell(poz)]
        rowContext.put(numeColoanaXLS,content)
        rowFieldContext.put(fieldEmsys,content)
        return  content;
      }
 
      def codserv=completeazaMap("Cod", 'codserv')
      def numeserv=completeazaMap("Denumire", 'numeserv')
      def tipserv=completeazaMap("Tip", 'tipserv')
      def configurat=completeazaMap("Configurat", 'configurat')
      def subgrupa=completeazaMap("Subgrupa", 'subgrupa')
      def grupa=completeazaMap("Grupa", 'grupa')
      def contVen=completeazaMap("Cont venituri", 'contVen')
      def contChelt=completeazaMap("Cont cheltuieli", 'contChelt')
      def codTaxaVnz=completeazaMap("Cod TVA vnz", 'codTaxaVnz')
      def codTaxaCmp=completeazaMap("Cod TVA cmp", 'codTaxaCmp')
      def zonach=completeazaMap("Zona", 'zonach')
      def codum=completeazaMap("UM", 'codum')
      def purtch=completeazaMap("Purtator", 'purtch')
      def numesort=completeazaMap("Den. scurta", 'numesort')
      
      if(codserv.value==null && numeserv.value==null && tipserv.value==null && configurat.value==null && subgrupa.value==null && grupa.value==null
        && contVen.value==null && contChelt.value==null && codTaxaVnz.value==null && codTaxaCmp.value==null && zonach.value==null && codum.value==null
        && purtch.value==null && numesort.value==null){
        return;
      }
	  def optext = completeazaMap("Accepta Denumire Extinsa", 'optext').value
	  if(!optext?.trim()){
	    optext = 'DA'
	  }
      
      def valuteObj = jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "valuteService","getValuteBRC",[idFirma, locale]).remoteSimpleObject;

      Calendar cal = Calendar.getInstance();
      cal.setTime(new Date()); 
      cal.set(Calendar.DAY_OF_YEAR, 1);    
      def datainc = cal.getTime();
      cal.set(Calendar.MONTH, 11);
      cal.set(Calendar.DAY_OF_MONTH, 31);
      cal.set(Calendar.YEAR, 2999);
      def datasf = cal.getTime();
      def hourFormat = new SimpleDateFormat("HH:mm")
      def mapNomServ=[
        'idFirma' : idFirma,
        'idUser' : idUser,
        'codserv' : codserv.value,
        'numeserv'  : numeserv.value,
        'tipserv' : tipserv.value,
        'dataact' : new Date(),
        'oraact': hourFormat.format(new Date()),
        'configurat' : configurat.value,
        'subgrupa' : subgrupa.value,
        'grupa' : grupa.value,
        'contVen' : contVen.value,
        'contChelt'  : contChelt.value,
        'codTaxaVnz' : codTaxaVnz.value,
        'tipTaxaVnz' : "TVA",
        'codTaxaCmp' : codTaxaCmp.value,
        'tipTaxaCmp' : "TVA",
        'zonach' : zonach.value,
        'codum' : codum.value,
        'purtch' : purtch.value,
        'numesort' : numesort.value,
        'stare': NomServService.STARE_ACTIV,
        'datainc': datainc,
        'datasf': datasf,
        'mrp': NomServService.MRP_NU,
        'cmdplan': NomServService.CMDPLAN_NU,
        'modpl': NomServService.MODPL_LFL,
        'mps': NomServService.MPS_NU,
        'codvalut': valuteObj.valutaBaza,
        'idSite' : 1,
        'pretvanz' : 0,
        'programare': "NU",
        'overBook': "NU",
        'duratacmd': 0,
		'optext': optext
      ]
      
      def flagInsert=true;
      
      if (insert) {
        def argsNomServ=[locale,mapNomServ,sdf]; 
        def returnObj=jsonRemotingService.invokeRemote("EMSYS_LOGISTICS", "nomServService","insert",argsNomServ);
        returnRowObj = returnObj.remoteRowObject
        println "the object is successInvocation ::: "+returnObj.successInvocation; 
        println "the object errorNomServ ::: "+returnObj.errorDetail; 
        println "the object errorMessage ::: "+returnObj.errorMessage; 
        println "the object errorMessage ::: "+returnObj.errorMessage; 
        println "the object jsonReturnValue ::: "+returnObj.jsonReturnValue; 
        println "the object remoteRowObject ::: "+returnObj.remoteRowObject;
        println "the object contains error ::: "+returnObj.remoteRowObject.containsErrors();
      } else {
        def argsInsOrUpd=[codserv.value,idFirma];

        def returnTemplateInsOrUpdate=jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomServService","findNomServRow",argsInsOrUpd); 
        def templateInsOrUpdate =returnTemplateInsOrUpdate.remoteRowObject
        println("templateInsOrUpdate:"+templateInsOrUpdate)
        if(templateInsOrUpdate==null){
               
          def argsNomServ=[locale,mapNomServ,sdf]; 
          returnRowObj=jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomServService","insert",argsNomServ).remoteRowObject
        }else{
          
          flagInsert=false;

          mapNomServ=[:]
          mapNomServ<<returnTemplateInsOrUpdate.remoteSimpleObject
          mapNomServ <<[
          'idFirma' : idFirma,
          'idUser' : idUser,
          'codserv' : codserv.value,
          'numeserv'  : numeserv.value,
          'tipserv' : tipserv.value,
          'dataact' : new Date(),
          'oraact': hourFormat.format(new Date()),
          'configurat' : configurat.value,
          'subgrupa' : subgrupa.value,
          'grupa' : grupa.value,
          'contVen' : contVen.value,
          'contChelt'  : contChelt.value,
          'codTaxaVnz' : codTaxaVnz.value,
          'codTaxaCmp' : codTaxaCmp.value,
          'zonach' : zonach.value,
          'codum' : codum.value,
          'purtch' : purtch.value,
          'numesort' : numesort.value,
		  'optext' : optext
          ]
          def argsNomServ=[locale,mapNomServ,sdf]; 
          returnRowObj=jsonRemoting.invokeRemote("EMSYS_LOGISTICS", "nomServService","update",argsNomServ).remoteRowObject
        }
      }
      
      if(returnRowObj==null){
        return;
      }
      
      if (configurat.value==null){
        returnRowObj.addMessage(EmsysMessage.ERROR_MESSAGE, "Valoare obligatorie!", null, "configurat");
      }
      
      if(returnRowObj.containsErrors()){
        suntErr=true;
        inregNecorespunzatoare++;
        def msgs=new StringBuilder();
        returnRowObj.messageList.each{emsMgs->
          println"emsMgs: ${emsMgs}"
          println"emsMgs.message: ${emsMgs.message}"
          if(emsMgs.field==null){
            msgs<<"${emsMgs.message} \n"
            
          }else{
            def rowCtx=rowFieldContext[emsMgs.field]
            def fld=fields[emsMgs.field]
            
            if (rowCtx!=null){
              
              def pocell=rowCtx.poiCell
              if (pocell!=null){
                pocell.setCellStyle(style);
              }
              msgs<<"${rowCtx.xlsField}: ${emsMgs.message}; \n"
              
            } else {
              msgs<<"${fld}: ${emsMgs.message}; \n"
            }
          }
        }
        def row=cloneSheet.getRow(rowNo);
        def cellNo=cloneSheet.getRow(0).getLastCellNum()
        row.createCell(cellNo).setCellValue(msgs.toString().substring(0, msgs.length()-1))

        if (returnRowObj.messageList.size()>1) {
          returnRowObj.messageList.size()<=10 ? row.setHeightInPoints((float)(row.getHeightInPoints() * returnRowObj.messageList.size()))
        : row.setHeightInPoints((float)(row.getHeightInPoints() * 10))
        }
          
      }else{
//        liniiOK<<rowNo
        inregAdaugate++;
        if (flagInsert){
          idList.add(['idFirma': idFirma, 'idUser': idUser, 'id': returnRowObj.values.id])
        }
      }
      println "the object contains errors ::: ${returnRowObj.containsErrors()}";
      
    });
  
  if (!idList.isEmpty() && suntErr){
    idList.each {item-> 
      println "se sterge nomServ cu id ${item.id}"
      def returnObjDel=jsonRemotingService.invokeRemote("EMSYS_LOGISTICS", "nomServService","delete",[locale, item]);
      
      println "the object is successInvocation ::: "+returnObjDel.successInvocation; 
      println "the object errorDetail ::: "+returnObjDel.errorDetail; 
      println "the object errorMessage ::: "+returnObjDel.errorMessage; 
      println "the object jsonReturnValue ::: "+returnObjDel.jsonReturnValue;
    }
  }
  
  cloneSheet.autoSizeColumn(cloneSheet.getRow(0).getLastCellNum(), false)
  cloneSheet.getRow(0).createCell(cloneSheet.getRow(0).getLastCellNum()).setCellValue("Erori")

//  println("Ok rows:${liniiOK}")
//  liniiOK=liniiOK.reverse();
//  liniiOK.each{idx->
//    def cloneRow=cloneSheet.getRow(idx);
//    cloneSheet.removeRow(cloneRow);
//    if(idx+1>cloneSheet.lastRowNum){
//      return;
//    }
//    cloneSheet.shiftRows(idx+1,cloneSheet.lastRowNum,-1)   
//  }
  
  
  File fn = new File(tmpFolder, "blabla.txt")
  fn.createNewFile()
  if(!suntErr){
    fn.text = "<html><body><div>Operatia s-a realizat cu succes! ${inregAdaugate} inregistrari au fost adaugate</div></body></html>"
    attachFile("Info.html", fn)
    
  }else{
    fn.text = "<html><body><div>In urma operatiei, ${inregNecorespunzatoare} inregistrari sunt necorespunzatoare/au erori. </div></body></html>"
    attachFile("Info.html", fn)
    File fisXLS=new File(tmpFolder,'errwwwws.xlsx');
    fisXLS.withOutputStream{os->
      cloneWb.write(os)
    }
    attachFile("Erori.xlsx",fisXLS)
  }
  
}catch(Exception e){
  throw new RuntimeException("Unable to load NomServ.xlsx file"+e);
} 
  

public void generateFieldDefinition(Locale locale ,ErpGroovyTemplatesService.Definition definition ){
  definition.addUploadField('nomServ','Fisier XLS').setOrder(20);
  definition.addBooleanField('insert','Doar adaugare (debifat se face update/adaugare)',true).setOrder(22);//.setTooltip("Daca este bifat se face doar adaugare, altfel daca exista inregistrarea se face update").setOrder(22);
}

import org.apache.poi.ss.usermodel.IndexedColors;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.BorderStyle;
import org.apache.poi.ss.usermodel.FillPatternType;  
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import com.prodinf.core.dataset.EmsysMessage;
import com.prodinf.logistics.log.def.service.NomServService;
import java.util.Calendar;
import java.util.Date;
import java.text.SimpleDateFormat;
import com.prodinf.core.dataset.EmsysMessage;